BuildRequires: maven2-plugin-site
Packager: Igor Vlasenko <viy@altlinux.ru>
BuildRequires: /proc
BuildRequires: jpackage-compat
# Copyright (c) 2000-2007, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#
%define gcj_support 0


# If you don't want to build with maven, and use straight ant instead,
# give rpmbuild option '--without maven'
%define with_maven %{!?_without_maven:1}%{?_without_maven:0}
%define without_maven %{?_without_maven:1}%{!?_without_maven:0}

%define parent plexus
%define subname containers
%define namedversion 1.0-alpha-34

Name:           %{parent}-%{subname}
Version:        1.0
Release:        alt5_0.1.a34.5jpp6
Epoch:          0
Summary:        Containers for Plexus
License:        Apache Software License 2.0
Group:          Development/Java
URL:            http://plexus.codehaus.org/
# svn export http://svn.codehaus.org/plexus/plexus-containers/tags/plexus-containers-1.0-alpha-44/
# tar czf plexus-containers-1.0-alpha-44.tar.gz plexus-containers-1.0-alpha-44/
Source0:        %{name}-%{namedversion}.tar.gz
Source1:        plexus-container-default-build.xml
Source2:        plexus-component-annotations-build.xml
Source3:        plexus-containers-settings.xml

Patch0:         plexus-containers-javadoc-junit-link.patch
Patch1:         plexus-containers-sourcetarget.patch


%if ! %{gcj_support}
BuildArch:      noarch
%endif

BuildRequires: jpackage-utils >= 0:1.7.3
%if %{with_maven}
BuildRequires: maven2 >= 2.0.4-10jpp
BuildRequires: maven2-plugin-compiler
BuildRequires: maven2-plugin-install
BuildRequires: maven2-plugin-jar
BuildRequires: maven2-plugin-javadoc
BuildRequires: maven2-plugin-resources
BuildRequires: maven-surefire-plugin
BuildRequires: maven-surefire-provider-junit
BuildRequires: maven-doxia
BuildRequires: maven-doxia-sitetools
BuildRequires: maven2-common-poms >= 1.0
BuildRequires: maven-release
%else
BuildRequires: ant >= 0:1.6.5
BuildRequires: ant-junit
BuildRequires: junit
%endif
BuildRequires: plexus-classworlds
BuildRequires: plexus-utils
%if %{gcj_support}
BuildRequires: java-gcj-compat-devel
Requires(post): java-gcj-compat
Requires(postun): java-gcj-compat
%endif

Requires: plexus-classworlds
Requires: plexus-utils

Requires(post): jpackage-utils >= 0:1.7.2
Requires(postun): jpackage-utils >= 0:1.7.2

%description
The Plexus project seeks to create end-to-end developer tools for
writing applications. At the core is the container, which can be
embedded or for a full scale application server. There are many
reusable components for hibernate, form processing, jndi, i18n,
velocity, etc. Plexus also includes an application server which
is like a J2EE application server, without all the baggage.


%package component-annotations
Summary:        Component API from %{name}
Group:          Development/Java
Requires: %{name} = %{epoch}:%{version}-%{release}
Requires: plexus-classworlds

%description component-annotations
%{summary}.

%package container-default
Summary:        Default Container from %{name}
Group:          Development/Java
Requires: %{name} = %{epoch}:%{version}-%{release}
Requires: plexus-classworlds
Requires: plexus-containers-component-annotations
Requires: plexus-utils
Provides:	plexus-containers-component-api = %{epoch}:%{version}-%{release}

%description container-default
%{summary}.

%package component-annotations-javadoc
Summary:        Javadoc for plexus-component-annotations
Group:          Development/Documentation
BuildRequires: java-javadoc
BuildRequires: jakarta-commons-collections-javadoc
BuildRequires: jakarta-commons-dbcp-javadoc
BuildRequires: jakarta-commons-fileupload-javadoc
BuildRequires: jakarta-commons-httpclient-javadoc
BuildRequires: jakarta-commons-logging-javadoc
BuildRequires: jakarta-commons-pool-javadoc
BuildRequires: log4j-javadoc
BuildRequires: regexp-javadoc
BuildRequires: velocity-javadoc
Requires: java-javadoc
Requires: jakarta-commons-collections-javadoc
Requires: jakarta-commons-dbcp-javadoc
Requires: jakarta-commons-fileupload-javadoc
Requires: jakarta-commons-httpclient-javadoc
Requires: jakarta-commons-logging-javadoc
Requires: jakarta-commons-pool-javadoc
Requires: log4j-javadoc
Requires: regexp-javadoc
Requires: velocity-javadoc

%description component-annotations-javadoc
%{summary}.

%package container-default-javadoc
Summary:        Javadoc for plexus-container-default
Group:          Development/Documentation

%description container-default-javadoc
%{summary}.

%prep
%setup -q -n plexus-containers-%{namedversion}

cp %{SOURCE1} plexus-container-default/build.xml
cp %{SOURCE2} plexus-component-annotations/build.xml

%patch0 -b .sav0
%patch1 -b .sav0

# Remove test that fails upstream as well
rm -f plexus-container-default/src/test/java/org/codehaus/plexus/logging/console/ConsoleLoggerTest.java

# to prevent ant from failing
mkdir -p plexus-component-annotations/src/test/java

%build

export MAVEN_REPO_LOCAL=$(pwd)/.m2/repository
mkdir -p $MAVEN_REPO_LOCAL

#FIXME:Why maven not support assert, "/UriConverter.java:[33,19] ';' expected"
sed -i "s|assert|// assert|g" plexus-container-default/src/main/java/org/codehaus/plexus/component/configurator/converters/basic/UriConverter.java

%if %{with_maven}
mvn-jpp -Dmaven.compile.target=1.5 -Dmaven.javadoc.source=1.5  \
        -Dmaven.repo.local=$MAVEN_REPO_LOCAL \
	-Dmaven.test.failure.ignore=true \
        install

    # Manual iteration should not be needed, but there is a bug in the javadoc 
    # plugin which makes this necessary. See: 
    # http://jira.codehaus.org/browse/MJAVADOC-157

    for module in container-default \
                  component-annotations; do
        pushd plexus-$module
mvn-jpp -Dmaven.compile.target=1.5 -Dmaven.javadoc.source=1.5  \
                -Dmaven.repo.local=$MAVEN_REPO_LOCAL \
                 javadoc:javadoc
        popd
    done

%else
export OPT_JAR_LIST="ant/ant-junit junit"
pushd plexus-component-annotations
export CLASSPATH=$(build-classpath \
plexus/classworlds \
)
ant -Dant.build.javac.source=1.5 -Dant.build.javac.target=1.5 -Dbuild.sysclasspath=only jar javadoc
popd
pushd plexus-container-default
rm src/test/java/org/codehaus/plexus/hierarchy/PlexusHierarchyTest.java
CLASSPATH=$CLASSPATH:$(build-classpath \
plexus/utils \
)
CLASSPATH=$CLASSPATH:../plexus-component-annotations/target/plexus-component-annotations-%{namedversion}.jar
CLASSPATH=$CLASSPATH:target/classes:target/test-classes
ant -Dant.build.javac.source=1.5 -Dant.build.javac.target=1.5 -Dbuild.sysclasspath=only jar javadoc
popd
%endif

%install
# jars
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}/plexus
install -pm 644 plexus-container-default/target/*.jar \
	  $RPM_BUILD_ROOT%{_javadir}/%{parent}/containers-container-default-%{version}.jar
install -pm 644 plexus-component-annotations/target/*.jar \
	  $RPM_BUILD_ROOT%{_javadir}/%{parent}/containers-component-annotations-%{version}.jar

(cd $RPM_BUILD_ROOT%{_javadir}/%{parent} && for jar in *-%{version}*; \
  do ln -sf ${jar} `echo $jar| sed  "s|-%{version}||g"`; done)

# pom
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/maven2/poms
install -pm 644 pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{parent}-%{subname}.pom
install -pm 644 plexus-container-default/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{parent}-containers-container-default.pom
install -pm 644 plexus-component-annotations/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{parent}-containers-component-annotations.pom
%add_to_maven_depmap org.codehaus.plexus %{name}  %{namedversion} JPP/%{parent} %{subname}
%add_to_maven_depmap org.codehaus.plexus containers-container-default %{namedversion} JPP/%{parent} containers-container-default
%add_to_maven_depmap org.codehaus.plexus containers-component-annotations  %{namedversion} JPP/%{parent} containers-component-annotations

# component-api is now folded into container-default
%add_to_maven_depmap org.codehaus.plexus containers-component-api  %{namedversion} JPP/%{parent} containers-container-default

# javadoc
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{parent}-containers-component-annotations-%{version}
%if %{with_maven}
cp -pr plexus-component-annotations/target/site/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{parent}-containers-component-annotations-%{version}
%else
# directory name is annotationsdocs while building with ant
ls -l plexus-component-annotations/target/site/
cp -pr plexus-component-annotations/target/site/annotationsdocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{parent}-containers-component-annotations-%{version}
%endif

install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{parent}-containers-container-default-%{version}

cp -pr plexus-container-default/target/site/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{parent}-containers-container-default-%{version}

ln -s %{parent}-containers-component-annotations-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{parent}-containers-component-annotations # ghost symlink
ln -s %{parent}-containers-container-default-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{parent}-containers-container-default # ghost symlink

%if %{gcj_support}
%{_bindir}/aot-compile-rpm
%endif

%post component-annotations-javadoc
rm -f %{_javadocdir}/plexus-containers-component-annotations
ln -s plexus-containers-component-annotations-%{version} %{_javadocdir}/plexus-containers-component-annotations

%postun component-annotations-javadoc
if [ "$1" = "0" ]; then
  rm -f %{_javadocdir}/plexus-containers-component-annotations
fi

%post container-default-javadoc
rm -f %{_javadocdir}/plexus-containers-container-default
ln -s plexus-containers-container-default-%{version} %{_javadocdir}/plexus-containers-container-default

%postun container-default-javadoc
if [ "$1" = "0" ]; then
  rm -f %{_javadocdir}/plexus-containers-container-default
fi

%files
%{_datadir}/maven2/poms/*
%{_mavendepmapfragdir}

%files component-annotations
%{_javadir}/%{parent}/containers-component-annotations*
%if %{gcj_support}
%dir %attr(-,root,root) %{_libdir}/gcj/%{name}
%{_libdir}/gcj/%{name}/containers-component-annotations*-%{version}.jar.*
%endif

%files container-default
%{_javadir}/%{parent}/containers-container-default*
%if %{gcj_support}
%dir %attr(-,root,root) %{_libdir}/gcj/%{name}
%{_libdir}/gcj/%{name}/containers-container-default*-%{version}.jar.*
%endif

%files component-annotations-javadoc
%doc %{_javadocdir}/plexus-containers-component-annotations-%{version}
%ghost %doc %{_javadocdir}/plexus-containers-component-annotations

%files container-default-javadoc
%doc %{_javadocdir}/plexus-containers-container-default-%{version}
%ghost %doc %{_javadocdir}/plexus-containers-container-default

%changelog
* Tue Feb 22 2011 Igor Vlasenko <viy@altlinux.ru> 0:1.0-alt5_0.1.a34.5jpp6
- fixed build

* Sun Feb 20 2011 Igor Vlasenko <viy@altlinux.ru> 0:1.0-alt4_0.1.a34.5jpp6
- fixed build

* Tue Feb 01 2011 Igor Vlasenko <viy@altlinux.ru> 0:1.0-alt3_0.1.a34.5jpp6
- fixed build

* Thu Sep 23 2010 Igor Vlasenko <viy@altlinux.ru> 0:1.0-alt2_0.1.a34.5jpp6
- new release a34

* Sun Feb 21 2010 Igor Vlasenko <viy@altlinux.ru> 0:1.0-alt1_0.a32.3jpp5
- new version

* Sat Sep 06 2008 Igor Vlasenko <viy@altlinux.ru> 0:1.0-alt1_0.a30.1jpp5
- converted from JPackage by jppimport script

